package main

import (
	"fmt"
	"sync"
)

func main() {
	// 并发对同一个内存空间 sum 进行修改，多次运行结果值是随机的，期待为 0
	var sum int
	group := &sync.WaitGroup{}

	add := func(group *sync.WaitGroup) {
		defer group.Done()
		for i := 0; i < 100; i++ {
			sum += i
		}
	}
	diff := func(group *sync.WaitGroup) {
		defer group.Done()
		for i := 0; i < 100; i++ {
			sum -= i
		}
	}

	for i := 0; i < 5; i++ {
		group.Add(2)
		go add(group)
		go diff(group)
	}

	group.Wait()
	fmt.Println(sum)
}
